<?php
/*---------------------------------------------------------
 *   Similar Topics Module for LiveStreet Engine.
 *   (c) 2009 asdx.
 *---------------------------------------------------------
 *   LiveStreet Engine Social Networking
 *   Copyright © 2008 Mzhelskiy Maxim
 *---------------------------------------------------------
 *   GNU General Public License, version 2:
 *   http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 *---------------------------------------------------------
 */

set_include_path(get_include_path().PATH_SEPARATOR.dirname(__FILE__));
require_once('mapper/SimilarTopics.mapper.class.php');

class LsSimilarTopics extends Module {
	protected $oMapperSimilarTopic = null;
	protected $oUserCurrent = null;
	
	public function Init() {
	    $this->oMapperSimilarTopic = new Mapper_SimilarTopics($this->Database_GetConnect());
	    $this->oUserCurrent=$this->User_GetUserCurrent();
	}
	
	public function GetSimilarTopics($oTopic){
	    $iCurrentUserId=-1;
	    if (is_object($this->oUserCurrent)) {
	        $iCurrentUserId=$this->oUserCurrent->getId();
	    }
	    $sTitleTags = $oTopic->GetTitle().",".$oTopic->getTags();
	    if (false === ($data = $this->Cache_Get("topic_filter_similar_{$oTopic->GetId()}_{$sTitleTags}_{$iCurrentUserId}"))) {
		$data = $this->oMapperSimilarTopic->GetSimilarTopics($oTopic->GetId(), $sTitleTags, $iCurrentUserId);
		$this->Cache_Set($data, "topic_filter_similar_{$oTopic->GetId()}_{$sTitleTags}_{$iCurrentUserId}", array('topic_update','topic_new'), 60*5);
	    }
	    return $data;
	}
}

?>
